// IsAdmin 2.5 (C) 2007-2015 VDT Software

var iapreftree = 'extensions.vdtisadmin.';
var iaiconstyles = new Array('classic', 'privbar', 'custom');

function iapref_get(prefname) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
     getService(Components.interfaces.nsIPrefBranch);

    if(prefs.getPrefType(prefname) == prefs.PREF_BOOL) {
        return prefs.getBoolPref(prefname);
    }
    if(prefs.getPrefType(prefname) == prefs.PREF_STRING) {
        return prefs.getCharPref(prefname);
    }
    if(prefs.getPrefType(prefname) == prefs.PREF_INT) {
        return prefs.getIntPref(prefname);
    }
    Components.utils.reportError("iapref_get can't find preference " + prefname);
    return false;
}

function iapref_getLocalizedString(prefname) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
     getService(Components.interfaces.nsIPrefBranch);
    return prefs.getComplexValue(prefname,
     Components.interfaces.nsIPrefLocalizedString).data;
}

function iapref_setString(prefname, value) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
     getService(Components.interfaces.nsIPrefBranch);
    prefs.setCharPref(prefname, value);
}	

function iapref_setBool(prefname, value) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
     getService(Components.interfaces.nsIPrefBranch);
	// prefs.setBoolPref(prefname, value);
	if (value) {
		prefs.setBoolPref(prefname, 1);
	} else {
		prefs.setBoolPref(prefname, 0);
	}
}	

function iapref_setInt(prefname, value) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
     getService(Components.interfaces.nsIPrefBranch);
    prefs.setIntPref(prefname, value);
}

function iapref_setLocalizedString(prefname, value) {
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].
     getService(Components.interfaces.nsIPrefBranch);
    var pls = Components.classes["@mozilla.org/pref-localizedstring;1"].
     createInstance(Components.interfaces.nsIPrefLocalizedString);
    pls.data = value;
    prefs.setComplexValue(prefname, Components.interfaces.nsIPrefLocalizedString, pls);
}


function iaopenPrefDlg() {
	window.openDialog( "chrome://isadmin/content/isadmin-prefdlg.xul", "_blank", "centerscreen,dialog,chrome,dependent" );
}

function iagetUsername() {
    try {
      const cid_u = "@mozilla.org/userinfo;1";
      var obj_u = Components.classes[cid_u].createInstance();
      obj_u = obj_u.QueryInterface(Components.interfaces.nsIUserInfo);
      return obj_u.username;
      //fullname and domain appear to be unavailable in Firefox 2.0.0.6 @ WinXP Home
    } catch(exc) {
      Components.utils.reportError("Error getting username: " + exc);
      return 'User unknown';
    }
}

function iamakeLabel(name) {
	return iapref_get(iapreftree + name).replace('%u', iagetUsername(), 'g');
}

function iamakeLabel_loc(name) {
	return iapref_getLocalizedString(iapreftree + name).replace('%u', iagetUsername(), 'g');
}

function iaiconURL(adminstatus) {
	var style = iapref_get(iapreftree + 'iconstyle');
	switch (adminstatus) {
		case true:
			switch (style) {
				case 'classic':
					return "chrome://isadmin/content/admin-yes.png";
				case 'privbar':
					return "chrome://isadmin/content/isadmin-pbred.png";
				case 'custom':
					return iapref_get(iapreftree + 'admin.iconURL');
			}
		case false:
			switch (style) {
				case 'classic':
					return "chrome://isadmin/content/admin-no.png";
				case 'privbar':
					return "chrome://isadmin/content/isadmin-pbgreen.png";
				case 'custom':
					return iapref_get(iapreftree + 'nonadmin.iconURL');
			}
	}
}

function iaisAdmin_ctypes() {
	/*
	Routine Description: This routine returns true if the caller's process
	is a member of the Administrators local group. Caller is NOT expected
	to be impersonating anyone and is expected to be able to open its own
	process and process token.
	Arguments: None
	Return Value:
	   true  - Caller has Administrators local group
	   false - Caller does not have Administrators local group (or as Deny token)
	*/

	Components.utils.import("resource://gre/modules/ctypes.jsm");

	//Check whether ctypes implementation is sufficiently complete (starting with Firefox 4.0b7)
	if (typeof ctypes.PointerType == "function") {
		//Defining types/values from Windows API headers (windows.h)
		var  BOOL   = ctypes.int;
		var PBOOL   = new ctypes.PointerType(BOOL);
		var BYTE    = ctypes.unsigned_char;
		var DWORD   = ctypes.unsigned_long;
		var PVOID   = ctypes.voidptr_t;
		var HANDLE  = ctypes.voidptr_t;
		var HMODULE = ctypes.voidptr_t;
		var LPCTSTR = new ctypes.PointerType(ctypes.jschar);
		var  SID_VALUE = new ctypes.ArrayType(BYTE, 6);
		var  SID_IDENTIFIER_AUTHORITY = new ctypes.StructType("SID_IDENTIFIER_AUTHORITY", [ {"Value": SID_VALUE} ]);
		var PSID_IDENTIFIER_AUTHORITY = new ctypes.PointerType(SID_IDENTIFIER_AUTHORITY);
		var  SID = ctypes.StructType("SID"); //opaque
		var PSID = new ctypes.PointerType(SID);
		var WINAPI = ctypes.winapi_abi;

		//#define SECURITY_NT_AUTHORITY	{0,0,0,0,0,5}
		var SECURITY_NT_AUTHORITY = new SID_IDENTIFIER_AUTHORITY;
			SECURITY_NT_AUTHORITY.Value[5] = 5;
		var SECURITY_BUILTIN_DOMAIN_RID = 32;
		var DOMAIN_ALIAS_RID_ADMINS = 0x220;
		var FAIL  = 0;
		var FALSE = 0;
		var TRUE  = 1;
	}
		
	//For loading libraries with full path to prevent insecure library loading
	//References: http://msdn.microsoft.com/en-us/library/ff919712.aspx  and  http://secunia.com/blog/120
	var sWinSysPath = Components.classes['@mozilla.org/file/directory_service;1'].createInstance(Components.interfaces.nsIProperties).get("SysD", Components.interfaces.nsIFile).path;
	
	var advapiLib = ctypes.open(sWinSysPath + "\\advapi32.dll");

	var AllocateAndInitializeSid = advapiLib.declare("AllocateAndInitializeSid", WINAPI, BOOL,
	  PSID_IDENTIFIER_AUTHORITY, BYTE, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, HANDLE /*PSID*/);
	//Note: The last parameter must be declared as a HANDLE (untyped pointer) rather than a PSID, or ctypes will have trouble creating the opaque struct
	//See http://msdn.microsoft.com/en-us/magazine/cc164123.aspx#S8 (read the section on Marshaling Opaque Pointers)

	var CheckTokenMembership = advapiLib.declare("CheckTokenMembership", WINAPI, BOOL,
	  HANDLE, PSID, PBOOL);

	var FreeSid = advapiLib.declare("FreeSid", WINAPI, PVOID, PSID);

	var isMember = BOOL();
	var NtAuthority = SECURITY_NT_AUTHORITY; //Type SID_IDENTIFIER_AUTHORITY
	var AdministratorsGroup = new PSID();

	var success = AllocateAndInitializeSid(
		NtAuthority.address(), 2, SECURITY_BUILTIN_DOMAIN_RID, DOMAIN_ALIAS_RID_ADMINS,
		0, 0, 0, 0, 0, 0, AdministratorsGroup.address());

	if (success) {
	  if (CheckTokenMembership(null, AdministratorsGroup, isMember.address()) == FAIL) {
		isMember = FALSE;
	  } //else: set by means of out param
	  FreeSid(AdministratorsGroup);
	}

	advapiLib.close();
	return (isMember.address().contents == 1);
}

var IsAdmin_ovl = {
  onLoad: function() {
	  
	var statuspanel = document.getElementById("vdtisadmin_panel");
	var showinstatusbar = iapref_get(iapreftree + 'showinstatusbar');
	if (showinstatusbar) {
		statuspanel.removeAttribute("hidden");
	} else {
		statuspanel.setAttribute("hidden", "true");
	}

    var img = document.getElementById("vdtisadmin_image");
    img.setAttribute("tooltiptext", "Administrator status unknown (ERR 2)");
    var label = document.getElementById("vdtisadmin_label");
    label.setAttribute("value", 'ERR 2');
	var button = document.getElementById("vdtisadmin_button");
	var have_addonbar = (button != null);
	var toolbarbutton = document.getElementById("vdtisadmin_toolbarbutton");
	var have_toolbarbutton = (toolbarbutton != null);

    var adminstatus;
    const cid = "@vdtsoftware.ffext/isadmin;1";
	if (cid in Components.classes) {
	  //On Firefox 3.6.x and earlier, use IsAdmin's binary XPCOM component to find admin status
      var obj = Components.classes[cid].createInstance();
      obj = obj.QueryInterface(Components.interfaces.IIsAdmin);
      adminstatus = obj.isadmin();
	} else {
	  //On Firefox 4.0b7 and later, use ctypes (XPCOM binary was not modified to be compatible)
	  adminstatus = iaisAdmin_ctypes();
	}

    img.setAttribute("src", iaiconURL(adminstatus));
    if (adminstatus) {
      img.setAttribute("tooltiptext", iamakeLabel_loc('admin.tooltip'));
      label.setAttribute("tooltiptext", iamakeLabel_loc('admin.tooltip'));
      label.setAttribute("value", iamakeLabel('admin.statustext'));
	  if (have_addonbar) {
	    button.setAttribute("label", iamakeLabel_loc('admin.tooltip'));
	    button.setAttribute("tooltiptext", iamakeLabel_loc('admin.tooltip'));
      }
	  if (have_toolbarbutton) {
		  toolbarbutton.setAttribute("tooltiptext", iamakeLabel_loc('admin.tooltip'));
		  toolbarbutton.setAttribute("image", iaiconURL(adminstatus));
	  }
    } else {
      img.setAttribute("tooltiptext", iamakeLabel_loc('nonadmin.tooltip'));
      label.setAttribute("tooltiptext", iamakeLabel_loc('nonadmin.tooltip'));
      label.setAttribute("value", iamakeLabel('nonadmin.statustext'));
	  if (have_addonbar) {
	    button.setAttribute("label", iamakeLabel_loc('nonadmin.tooltip'));
	    button.setAttribute("tooltiptext", iamakeLabel_loc('nonadmin.tooltip'));
      }
	  if (have_toolbarbutton) {
		  toolbarbutton.setAttribute("tooltiptext", iamakeLabel_loc('nonadmin.tooltip'));
		  toolbarbutton.setAttribute("image", iaiconURL(adminstatus));
	  }
    }

    if (label.value == '') {
      label.setAttribute("collapsed", true);
    } else {
      label.setAttribute("collapsed", false);
    }    	

    if (img.src == '') {
      img.setAttribute("collapsed", true);
    } else {
      img.setAttribute("collapsed", false);
    }    	
  }
};
